#region using namespace
using System;
using System.Configuration;
using System.IO;
using System.Text;
using System.Web.Services;
using System.Xml;
using System.Linq;
using AvaCorp.Virtual.BLL;
using AvaCorp.Virtual.Util;
using System.Text.RegularExpressions;
using System.Collections.Generic;
#endregion

[WebService(Namespace = "jetclass")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class AvaCorpVirtual : System.Web.Services.WebService
{
    #region Construtor
    public AvaCorpVirtual()
    {
        Krypto krypto = new Krypto();
        Auditoria.GravarLog = Convert.ToBoolean(ConfigurationManager.AppSettings["Log"]);
        Configuracao.CaminhoExportacaoXML = Server.MapPath(@"Temp\Xml\");
        Configuracao.EmailDuplicidadeDocumentoEletronico = ConfigurationManager.AppSettings["EmailDuplicidadeDocumentoEletronico"];
        Configuracoes.ExcluirXmlEnvio = Convert.ToBoolean(ConfigurationManager.AppSettings["ExcluirXmlEnvio"]);
        Configuracoes.ExcluirXmlRetornoEnvio = Convert.ToBoolean(ConfigurationManager.AppSettings["ExcluirXmlRetornoEnvio"]);
        Configuracoes.WebSiteConsulta = ConfigurationManager.AppSettings["WebSiteConsulta"];
        Configuracoes.WebSiteConsultaCTe = ConfigurationManager.AppSettings["WebSiteConsultaCte"];
        Configuracoes.WebSiteConsultaXML = ConfigurationManager.AppSettings["WebSiteConsultaXML"];
        Configuracoes.WebServiceScanProdNfeConsulta2 = ConfigurationManager.AppSettings["WebServiceScanProdNfeConsulta2"];
        Configuracoes.WebServiceScanHomNfeConsulta2 = ConfigurationManager.AppSettings["WebServiceScanHomNfeConsulta2"];
        Configuracoes.WebServiceDPECProdNfeConsulta2 = ConfigurationManager.AppSettings["WebServiceDPECProdNfeConsulta2"];
        Configuracoes.WebServiceDPECHomNfeConsulta2 = ConfigurationManager.AppSettings["WebServiceDPECHomNfeConsulta2"];
        Configuracoes.EmailRetorno = ConfigurationManager.AppSettings["EmailRetorno"];
        Configuracoes.EmailCopia = ConfigurationManager.AppSettings["EmailCopia"];
        Configuracoes.ValidarDigValExportacaoXML = Convert.ToBoolean(ConfigurationManager.AppSettings["ValidarDigValExportacaoXML"]);
        Configuracoes.UrlEDIWS = ConfigurationManager.AppSettings["UrlEDIWS"];
        DALConnections.ConnectionString = krypto.ConnectionStringDecrypt(ConfigurationManager.ConnectionStrings["default"].ConnectionString);
        //DALConnections.XmlConnectionString = krypto.ConnectionStringDecrypt(ConfigurationManager.ConnectionStrings["XMLConnectionString"].ConnectionString);
        Serializacao.CaminhoExportacao = Server.MapPath(@"Xml\Envio\");
        Serializacao.CaminhoRetorno = Server.MapPath(@"Xml\Retorno\");
        Serializacao.CaminhoCancelamento = Server.MapPath(@"Xml\Cancelamento\");
        Serializacao.CaminhoInutilizacao = Server.MapPath(@"Xml\Inutilizacao\");
        Serializacao.CaminhoSchema = Server.MapPath(@"Schema\");
        Serializacao.CaminhoStatusServico = Server.MapPath(@"Xml\StatusServico\");
        Serializacao.CaminhoConsultaSituacao = Server.MapPath(@"Xml\ConsultaSituacao\");
        Serializacao.CaminhoSimCompleta = Server.MapPath(@"Xml\ConsultaSim\Completa\");
        Serializacao.CaminhoSimResumida = Server.MapPath(@"Xml\ConsultaSim\Resumida\");
        Serializacao.CaminhoConsultaRecibo = Server.MapPath(@"Xml\ConsultaRecibo\");
        Serializacao.CaminhoRetornoConsultaRecibo = Server.MapPath(@"Xml\RetornoConsultaRecibo\");
        Serializacao.MailImagePath = ConfigurationManager.AppSettings["LogoEmpresa"];
        Serializacao.MailHtmlFileCTe = ConfigurationManager.AppSettings["TemplateCTe"];
        Serializacao.MailHtmlFileNFe = ConfigurationManager.AppSettings["TemplateNFe"];
        Serializacao.MailHtmlFileFatura = ConfigurationManager.AppSettings["TemplateFatura"];
        AvaCorp.Virtual.Types.Empresa_Configuracao.EmailIntegracaoDocumentoEletronico = ConfigurationManager.AppSettings["EmailIntegracaoDocumentoEletronico"];
    }
    #endregion

    #region private attributes
    AvaCorp.Virtual.Types.Retorno retorno = new AvaCorp.Virtual.Types.Retorno();
    #endregion

    #region WebMethods

    #region SEFAZ
    [WebMethod]
    public AvaCorp.Virtual.Types.Retorno EnviarDocumentoEletronico(string pChaveAcesso, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade, int pCodigoUsuario, Int64 pNumeroLote)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\EnviarDocumentoEletronico\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}_{3}.log", pNumeroLote.ToString().PadLeft(9, '0'), DateTime.Now.ToString("HHmmss"), pCodigoUsuario.ToString(), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            AvaCorp.Virtual.WS.Enviar enviar = new AvaCorp.Virtual.WS.Enviar();
            return enviar.DocumentoEletronico(pChaveAcesso, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pCodigoUsuario, pNumeroLote);
        }
        catch (Exception ex)
        {
            Auditoria.GravaMensagem(string.Format("{0}\r\n{1}", ex.Message, ex.StackTrace));
            throw;
        }
        finally
        {
            if (Auditoria.GravarLog) auditoria.CloseMonitor();
        }
    }

    [WebMethod]
    public System.Collections.Generic.List<AvaCorp.Virtual.Types.CertificadoDigital> Certificados()
    {
        try
        {
            AvaCorp.Virtual.BLL.Certificado certificado = new AvaCorp.Virtual.BLL.Certificado();
            return certificado.Lista();
        }
        catch (InvalidOperationException ex)
        {
            throw new Exception(ex.Message);
        }
        catch (Exception ex)
        {
            throw new Exception(ex.Message);
        }
    }

    /// <summary>
    /// Atualiza o nmero do serial no sistema
    /// </summary>
    /// <param name="Grupo">Grupo a ser atualizado</param>
    /// <param name="Empresa">Empresa para ser atualizada</param>
    /// <param name="NumeroSerial">Nmero serial do certificado digital</param>
    [WebMethod]
    public bool CertificadoDigitalAtualiza(int Grupo, int Empresa, string NumeroSerial)
    {
        try
        {
            AssinaturaDigital assinatura = new AssinaturaDigital();
            AvaCorp.Virtual.Types.CertificadoDigital certificado = assinatura.Certificado(NumeroSerial);
            return Empresa_Configuracao.UpdateCertificadoDigital(Grupo, Empresa, NumeroSerial, certificado.ValidTo);
        }
        catch (InvalidOperationException ex)
        {
            throw new Exception(ex.Message);
        }
        catch (Exception ex)
        {
            throw new Exception(ex.Message);
        }

    }

    [WebMethod]
    public string ConsultaCadastro(string pUF, int pTipoDocumento, string pCodigoDocumento)
    {
        return "Mtodo no implementado.";
    }

    [WebMethod]
    public XmlDocument ConsultaDocumento(string pChaveAcesso)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\ConsultaDocumento\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}.log", pChaveAcesso, DateTime.Now.ToString("HHmmss"), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            AvaCorp.Virtual.WS.SituacaoDocumento situacaoDocumento = new AvaCorp.Virtual.WS.SituacaoDocumento();
            return situacaoDocumento.Consultar(pChaveAcesso);
        }
        finally
        {
            #region fechar log

            if (Auditoria.GravarLog) auditoria.CloseMonitor();

            #endregion
        }
    }

    [WebMethod]
    public AvaCorp.Virtual.Types.DocumentoEletronicoLote_Documento SelectDocumentoByChaveAcesso(string pChaveAcesso)
    {
        DocumentoEletronicoLote_Documento documentoEletronicoLote_Documento = new DocumentoEletronicoLote_Documento();
        return documentoEletronicoLote_Documento.Select(pChaveAcesso);
    }

    [WebMethod]
    public string ExportarXmlDynamic(int pGrupo, int pEmpresa, string pUF, int pTipoDocumento, long pNumeroLote, string pChaveAcessoDocumentoEletronico, string versao)
    {
        return ExportXML(pChaveAcessoDocumentoEletronico);
    }

    /// <summary>
    /// Exporta do Documento no layout de distribuio ao cliente
    /// </summary>
    /// <param name="ChaveAcesso">Chave de Acesso do documento eletrnico</param>
    /// <returns>XML conforme layout de distribuio</returns>
    [WebMethod]
    public string ExportXML(string ChaveAcesso)
    {
        Auditoria auditoria = new Auditoria();

        #region cria log
        if (Auditoria.GravarLog)
        {
            Auditoria.PathLog = Server.MapPath(String.Format(@"Log\ExportXML\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
            Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}.log", ChaveAcesso, DateTime.Now.ToString("HHmmss"), Guid.NewGuid());
            auditoria.OpenMonitor();
        }
        #endregion

        AvaCorp.Virtual.Types.XmlDocumentoEletronicoLote_Documento documento = new AvaCorp.Virtual.Types.XmlDocumentoEletronicoLote_Documento();
        try
        {
            string urlWebService = System.Web.HttpContext.Current.Request.Url.OriginalString.Replace("/ExportXML", "");
            DALConnections.BeginTransaction();
            XmlDocumentoEletronicoLote xmlLote = new XmlDocumentoEletronicoLote();
            documento = new AvaCorp.Virtual.BLL.XmlDocumentoEletronicoLote_Documento().Select(ChaveAcesso);
            AboutJetClass.Select();

            // Verifica a existncia de XML de envio para o documento
            if (String.IsNullOrEmpty(documento.XmlEnvio))
                GerarXmlEnvio(documento.Grupo, documento.Empresa, documento.TipoDocumento, documento.FilialDocumento, documento.UnidadeDocumento, documento.UF, 1, documento.NumeroLote);

            #region Obtm XML de Retorno do SEFAZ
            for (int i = 0; i < 2; i++)
            {
                // Verifica a existncia de XML de Retorno de Processamento.
                // Se o parametro estiver ativo, verifica se o XML possui a tag digVal.
                if (String.IsNullOrEmpty(documento.XmlRetornoProcessamento)
                    || (
                        (documento.TipoDocumento != 6 || Decimal.Parse(documento.VersaoLayout, new System.Globalization.CultureInfo("en-US")) > new Decimal(1.02)) // Condio para no verificar inutilmente os CTes de verses anteriores
                        && Configuracoes.ValidarDigValExportacaoXML && !xmlLote.XmlRetornoProcessamentoPossuiDigVal(documento.XmlRetornoProcessamento))
                )
                {
                    if (i == 0) // Tenta Buscar o Retorno de Recibo de Lote
                    {
                        Auditoria.GravaMensagem("Buscando o retorno do recibo");
                        Empresa_Configuracao.Select(documento.Grupo, documento.Empresa);
                        RetornoRecepcaoDocumentoEletronico(AvaCorp.Virtual.Types.Empresa_Configuracao.ChaveAcessoWebServiceDocumentoEletronico, documento.TipoDocumento, documento.Grupo, documento.Empresa, documento.FilialDocumento, documento.UnidadeDocumento, documento.ReciboEntrega.ToString());
                    }
                    else if (i == 1) // Se no conseguir obter o XML de Retorno de Recibo de Lote, tenta criar o XML de retorno
                    {
                        Auditoria.GravaMensagem("Criando retorno do recibo");
                        AvaCorp.Virtual.WS.Retorno retorno = new AvaCorp.Virtual.WS.Retorno();
                        retorno.GeraXmlRetornoProcessamentoPorDocumento(documento.Grupo, documento.Empresa, documento.UF, documento.TipoDocumento, documento.NumeroLote);
                    }
                    // Recarrega Documento
                    documento = new AvaCorp.Virtual.BLL.XmlDocumentoEletronicoLote_Documento().Select(ChaveAcesso);
                }
                else break;
            }
            #endregion

            // Recarrega Documento
            if (String.IsNullOrEmpty(documento.XmlEnvio))
                documento = new AvaCorp.Virtual.BLL.XmlDocumentoEletronicoLote_Documento().Select(ChaveAcesso);

            // Se no encontrou o XML de retorno de Processamento, ento deve retornar mensagem de erro
            if (String.IsNullOrEmpty(documento.XmlRetornoProcessamento))
            {
                Auditoria.GravaMensagem("ERRO: O XML de Retorno de Processamento no est gravado na tabela XmlDocumentoEletronico. Verifique.");
                return string.Format("<ERRO><ChaveAcesso>{0}</ChaveAcesso><Motivo>O XML de Retorno de Processamento no est disponvel. Entre em contato com a AvaCorp para verificar o problema.</Motivo></ERRO>", ChaveAcesso);
            }

            #region Gerao atravs EDIWS
            #region CTe v2.00/v3.00
            if (documento.TipoDocumento == 6)
            {
                XmlDocument xmlEnvio = new XmlDocument();

                if (!string.IsNullOrEmpty(documento.XmlEnvio) && !string.IsNullOrEmpty(documento.XmlRetornoEnvio))
                {
                    xmlEnvio.LoadXml(documento.XmlEnvio);

                    XmlNode rootNode = xmlEnvio.GetElementsByTagName("infCte")[0];
                    if (rootNode.Attributes["versao"].Value == "2.00" || rootNode.Attributes["versao"].Value == "3.00")
                    {
                        // Se vai fazer a transmisso pelo EDIWS, aborta a transao, pois ela no  mais necessria
                        if (DALConnections.InTransaction) DALConnections.RollbackTransaction();

                        var xmlCTe = new Services.CTe.ArquivoXML();
                        return xmlCTe.ExportXml(ChaveAcesso);
                    }
                }
            }
            #endregion
            #region NFe v3.10
            if (documento.TipoDocumento == 12)
            {
                XmlDocument xmlEnvio = new XmlDocument();

                if (!string.IsNullOrEmpty(documento.XmlEnvio) && !string.IsNullOrEmpty(documento.XmlRetornoEnvio))
                {
                    xmlEnvio.LoadXml(documento.XmlEnvio);

                    XmlNode rootNode = xmlEnvio.GetElementsByTagName("infNFe")[0];
                    if (rootNode.Attributes["versao"].Value == "3.10")
                    {
                        // Se vai fazer a transmisso pelo EDIWS, aborta a transao, pois ela no  mais necessria
                        if (DALConnections.InTransaction) DALConnections.RollbackTransaction();

                        var xmlNFe = new Services.NFe.ArquivoXML();
                        return xmlNFe.ExportXml(ChaveAcesso);
                    }
                }
            }
            #endregion
            #endregion


            // Preenche o tipo dos argumentos
            List<Type> tipoArgumentos = new List<Type>();
            tipoArgumentos.Add(typeof(int));
            tipoArgumentos.Add(typeof(int));
            tipoArgumentos.Add(typeof(string));
            tipoArgumentos.Add(typeof(int));
            tipoArgumentos.Add(typeof(long));
            tipoArgumentos.Add(typeof(string));
            // Preenche o valor dos argumentos
            List<object> valorArgumentos = new List<object>();
            valorArgumentos.Add(documento.Grupo);
            valorArgumentos.Add(documento.Empresa);
            valorArgumentos.Add(documento.UF);
            valorArgumentos.Add(documento.TipoDocumento);
            valorArgumentos.Add(documento.NumeroLote);
            valorArgumentos.Add(ChaveAcesso);

            // Invoco o metodo passando a instancia da classe (construtor)  e os parametros do metodo
            XmlDocument xmlModificar = GetTypeExportXML(documento.TipoDocumento, documento.VersaoLayout, "GetXmlChaveAcesso", tipoArgumentos, valorArgumentos);

            XmlDocument xmlProcessado = new XmlDocument();
            #region modifica tag por tipo documento
            if (documento.TipoDocumento == 12)
                xmlProcessado.LoadXml(xmlModificar.InnerXml.Replace("<NFe>", "<NFe xmlns='http://www.portalfiscal.inf.br/nfe'>"));
            else
                xmlProcessado.LoadXml(xmlModificar.InnerXml.Replace("<CTe>", "<CTe xmlns='http://www.portalfiscal.inf.br/cte'>"));
            #endregion

            if (DALConnections.InTransaction) DALConnections.CommitTransaction();
            return xmlProcessado.InnerXml;
        }
        catch (Exception ex)
        {
            if (DALConnections.InTransaction) DALConnections.RollbackTransaction();
            #region Informaes do log
            StringBuilder parametros = new StringBuilder();
            parametros.AppendFormat("Grupo: {0}\t", documento.Grupo);
            parametros.AppendFormat("Empresa: {0}\t", documento.Empresa);
            parametros.AppendFormat("UF: {0}\t", documento.UF);
            parametros.AppendFormat("TipoDocumento: {0}\t", documento.TipoDocumento);
            parametros.AppendFormat("Lote: {0}\t", documento.NumeroLote);
            parametros.AppendFormat("Chave Acesso: {0}\t", ChaveAcesso);
            parametros.AppendFormat("Verso: {0}\t", documento.VersaoLayout);

            Auditoria.GravaMensagem(parametros.ToString());
            Auditoria.GravaMensagem(ex.Message);
            if (ex.InnerException != null) Auditoria.GravaMensagem(Convert.ToString(ex.InnerException));
            if (Auditoria.GravarLog) auditoria.CloseMonitor();
            #endregion
            return null;
        }
    }

    [WebMethod]
    public string ExportXMLCancelamento(string ChaveAcesso)
    {
        Auditoria auditoria = new Auditoria();

        #region cria log
        if (Auditoria.GravarLog)
        {
            Auditoria.PathLog = Server.MapPath(String.Format(@"Log\ExportXMLCancelamento\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
            Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}.log", ChaveAcesso, DateTime.Now.ToString("HHmmss"), Guid.NewGuid());
            auditoria.OpenMonitor();
        }
        #endregion

        var documento = new AvaCorp.Virtual.Types.DocumentoEletronicoLote_Documento();
        try
        {
            // Seta CultureInfo para garantir que no ter problema com formatao de decimal
            System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("en-US");

            documento = new AvaCorp.Virtual.BLL.DocumentoEletronicoLote_Documento().Select(ChaveAcesso);

            // Verifica se a verso do documento  compatvel com a DLL. Verses mais antigas no podero exportar o XML
            if ((documento.TipoDocumento == 6 && Double.Parse(documento.VersaoLayout) < 1.04)
                || (documento.TipoDocumento == 12 && Double.Parse(documento.VersaoLayout) < 2.00))
            {
                throw new Exception(string.Format("O servio de exportao de XML de Cancelamento no est disponvel na verso {0} deste documento eletrnico.", documento.VersaoLayout));
            }

            #region Gerao atravs EDIWS
            #region CTe v2.00/v3.00
            if (documento.TipoDocumento == 6)
            {
                XmlDocument xmlEnvio = new XmlDocument();

                var bllXmlCanc = new AvaCorp.Virtual.BLL.XmlDocumentoEletronicoCancelamento();
                var xmlCanc = bllXmlCanc.SelectByChaveAcesso(ChaveAcesso);

                if (!string.IsNullOrEmpty(xmlCanc.XmlEnvio) && !string.IsNullOrEmpty(xmlCanc.XmlRetorno))
                {
                    xmlEnvio.LoadXml(xmlCanc.XmlEnvio);

                    XmlNode rootNode = xmlEnvio.GetElementsByTagName("eventoCTe")[0];
                    if (rootNode.Attributes["versao"].Value == "2.00" || rootNode.Attributes["versao"].Value == "3.00")
                    {
                        // Se vai fazer a transmisso pelo EDIWS, aborta a transao, pois ela no  mais necessria
                        if (DALConnections.InTransaction) DALConnections.RollbackTransaction();

                        var xmlCTe = new Services.CTe.ArquivoXML();
                        return xmlCTe.ExportXmlCancelamento(ChaveAcesso);
                    }
                }
            }
            #endregion
            #region NFe v3.10
            if (documento.TipoDocumento == 12)
            {
                XmlDocument xmlEnvio = new XmlDocument();

                var bllXmlCanc = new AvaCorp.Virtual.BLL.XmlDocumentoEletronicoCancelamento();
                var xmlCanc = bllXmlCanc.SelectByChaveAcesso(ChaveAcesso);

                if (!string.IsNullOrEmpty(xmlCanc.XmlEnvio) && !string.IsNullOrEmpty(xmlCanc.XmlRetorno))
                {
                    xmlEnvio.LoadXml(xmlCanc.XmlEnvio);

                    XmlNode rootNode = xmlEnvio.GetElementsByTagName("evento")[0];
//                    if (rootNode.Attributes["versao"].Value == "3.10")
//                    {
                        // Se vai fazer a transmisso pelo EDIWS, aborta a transao, pois ela no  mais necessria
                        if (DALConnections.InTransaction) DALConnections.RollbackTransaction();

                        var xmlNFe = new Services.NFe.ArquivoXML();
                        return xmlNFe.ExportXmlCancelamento(ChaveAcesso);
//                    }
                }
            }
            #endregion
            #endregion

            // Preenche o tipo dos argumentos
            List<Type> tipoArgumentos = new List<Type>();
            tipoArgumentos.Add(typeof(int));
            tipoArgumentos.Add(typeof(string));

            // Preenche o valor dos argumentos
            List<object> valorArgumentos = new List<object>();
            valorArgumentos.Add(documento.TipoDocumento);
            valorArgumentos.Add(ChaveAcesso);

            XmlDocument xmlCancelamento = GetTypeExportXML(documento.TipoDocumento, documento.VersaoLayout, "GetXmlCancelamentoChaveAcesso", tipoArgumentos, valorArgumentos);
            return xmlCancelamento.InnerXml;
        }
        catch (Exception ex)
        {
            if (DALConnections.InTransaction) DALConnections.RollbackTransaction();
            #region Informaes do log
            StringBuilder parametros = new StringBuilder();
            parametros.AppendFormat("Grupo: {0}\t", documento.Grupo);
            parametros.AppendFormat("Empresa: {0}\t", documento.Empresa);
            parametros.AppendFormat("UF: {0}\t", documento.UF);
            parametros.AppendFormat("TipoDocumento: {0}\t", documento.TipoDocumento);
            parametros.AppendFormat("Lote: {0}\t", documento.NumeroLote);
            parametros.AppendFormat("Chave Acesso: {0}\t", ChaveAcesso);
            parametros.AppendFormat("Verso: {0}\t", documento.VersaoLayout);

            Auditoria.GravaMensagem(parametros.ToString());
            Auditoria.GravaMensagem(ex.Message);
            if (ex.InnerException != null) Auditoria.GravaMensagem(Convert.ToString(ex.InnerException));
            if (Auditoria.GravarLog) auditoria.CloseMonitor();
            #endregion
            return null;
        }
    }

    [WebMethod]
    public bool GerarXmlEnvio(int pGrupo, int pEmpresa, int pTipoDocumento, int pFilial, int pUnidade, string pUF, int pCodigoUsuario, Int64 pNumeroLote)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\GerarXmlEnvio\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}_{3}.log", pNumeroLote.ToString().PadLeft(9, '0'), DateTime.Now.ToString("HHmmss"), pCodigoUsuario.ToString(), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            #region abrindo conexo / carregando parmetros
            DALConnections.BeginTransaction();
            Configuracoes.GetParametros(pGrupo, pEmpresa, pFilial, pUnidade, pTipoDocumento);
            #endregion

            Serializacao serializacao = new Serializacao();
            XmlDocumentoEletronicoLote xmlLote = new XmlDocumentoEletronicoLote();
            AvaCorp.Virtual.Types.XmlDocumentoEletronicoLote lote = xmlLote.Select(pGrupo, pEmpresa, pUF, pTipoDocumento, pNumeroLote);

            if (String.IsNullOrEmpty(lote.XmlEnvio))
            {
                int servicoDocumentoEletronico = pTipoDocumento == 12 ? 20 : 2;
                AvaCorp.Virtual.Types.Estado_ParametroDocumentoEletronico estado = new Estado_ParametroDocumentoEletronico().Select("BRA", AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, servicoDocumentoEletronico);
                lote.XmlEnvio = serializacao.ExportaDocumento(AvaCorp.Virtual.Types.Empresa_Configuracao.ChaveAcessoWebServiceDocumentoEletronico, pGrupo, pEmpresa, pFilial, pUnidade, pTipoDocumento, pNumeroLote, true, estado, 1).OuterXml;
                xmlLote.GravaXmlEnvio(pGrupo, pEmpresa, pUF, pTipoDocumento, pNumeroLote, lote.XmlEnvio);
            }
            DALConnections.CommitTransaction();
            return true;
        }
        catch (Exception ex)
        {
            DALConnections.RollbackTransaction();
            throw ex;
            //return false;
        }
        finally
        {
            if (Auditoria.GravarLog) auditoria.CloseMonitor();
        }
    }

    [WebMethod]
    public AvaCorp.Virtual.Types.Retorno CopiaEletronicaFatura(int pGrupo, int pEmpresa, int pFilial, int pUnidade, int pSequencia)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\CopiaEletronicaFatura\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}.log", pSequencia.ToString().PadLeft(9, '0'), DateTime.Now.ToString("HHmmss"), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            AvaCorp.Virtual.WS.CopiaEletronica copiaEletronica = new AvaCorp.Virtual.WS.CopiaEletronica();
            return copiaEletronica.Fatura(pGrupo, pEmpresa, pFilial, pUnidade, pSequencia, "", "");
        }
        finally
        {
            if (Auditoria.GravarLog) auditoria.CloseMonitor();
        }
    }

    [WebMethod]
    public AvaCorp.Virtual.Types.Retorno CopiaEletronicaFatura_EmailEspecifico(int pGrupo, int pEmpresa, int pFilial, int pUnidade, int pSequencia, string pDestinatario, string pNickName)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\CopiaEletroniciaFatura_Email\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}.log", pSequencia.ToString().PadLeft(9, '0'), DateTime.Now.ToString("HHmmss"), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            AvaCorp.Virtual.WS.CopiaEletronica copiaEletronica = new AvaCorp.Virtual.WS.CopiaEletronica();
            return copiaEletronica.Fatura(pGrupo, pEmpresa, pFilial, pUnidade, pSequencia, pDestinatario, pNickName);
        }
        finally
        {
            if (Auditoria.GravarLog) auditoria.CloseMonitor();
        }
    }

    [WebMethod]
    public AvaCorp.Virtual.Types.Retorno RetornoRecepcaoDocumentoEletronico(string pChaveAcesso, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade, string pNumeroRecibo)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\RetornoRecepcaoDocumentoEletronico\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}.log", pNumeroRecibo, DateTime.Now.ToString("HHmmss"), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            if (pNumeroRecibo.Length != 15) throw new Exception("Recibo invalido. O numero deve conter 15 caracteres.");

            AvaCorp.Virtual.Types.Retorno retorno = new AvaCorp.Virtual.Types.Retorno();
            AvaCorp.Virtual.WS.Retorno ws = new AvaCorp.Virtual.WS.Retorno();

            string reciboEntregaOriginal = String.Empty;
            retorno = ws.GetDocumentoEletronicoProcessado(pChaveAcesso, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pNumeroRecibo, out reciboEntregaOriginal);

            if (!String.IsNullOrEmpty(reciboEntregaOriginal))
                retorno = ws.GetDocumentoEletronicoProcessado(pChaveAcesso, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, reciboEntregaOriginal, out reciboEntregaOriginal);

                #region Atualiza a tabela logSistema
                System.Diagnostics.StackFrame stack = new System.Diagnostics.StackFrame(2);
                string rotina = stack.GetMethod().ToString();
                int usuario = 1;
                string mensagem;
                string contexto;

                #region Atualiza a tabela logSistema apos consulta

                contexto = "Retorno documento eletronico";
                mensagem = string.Format("N Recibo: {0}", pNumeroRecibo);
                AvaCorp.Virtual.BLL.LogSistema.LogUtilizacaoServicos(usuario, rotina, mensagem, contexto);
                #endregion
                #endregion


            return retorno;
        }
        finally
        {
            if (Auditoria.GravarLog) auditoria.CloseMonitor();
        }
    }

    [WebMethod]
    public XmlNode ConsultarSituacaoDocumento(string pChaveAcesso, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade, string pCnpjCpfCodigoEmissor, int pDiferenciadorNumero, int pSerie, int pNumero)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\ConsultarSituacaoDocumento\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}.log", pNumero, DateTime.Now.ToString("HHmmss"), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            AvaCorp.Virtual.WS.SituacaoDocumento situacaoDocumento = new AvaCorp.Virtual.WS.SituacaoDocumento();
            return situacaoDocumento.Consultar(pChaveAcesso, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pCnpjCpfCodigoEmissor, pDiferenciadorNumero, pSerie, pNumero);
        }
        finally
        {
            #region fechar log

            if (Auditoria.GravarLog) auditoria.CloseMonitor();

            #endregion
        }
    }

    [WebMethod]
    public AvaCorp.Virtual.Types.Retorno CancelamentoDocumentoEletronico(string pChaveAcesso, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade, string pCnpjCpfCodigoEmissorDocumento, int pDiferenciadorNumero, int pSerie, int pNumero, int pCodigoUsuario, string pJustificativa)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\CancelamentoDocumentoEletronico\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}_{3}.log", pNumero.ToString().PadLeft(9, '0'), DateTime.Now.ToString("HHmmss"), pCodigoUsuario.ToString(), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            AvaCorp.Virtual.WS.Cancelar cancelar = new AvaCorp.Virtual.WS.Cancelar();
            return cancelar.DocumentoEletronico(pChaveAcesso, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pCnpjCpfCodigoEmissorDocumento,
                pDiferenciadorNumero, pSerie, pNumero, pCodigoUsuario, pJustificativa);
        }
        finally
        {
            #region fechar log

            if (Auditoria.GravarLog) auditoria.CloseMonitor();

            #endregion
        }
    }

    [WebMethod]
    public AvaCorp.Virtual.Types.Retorno InutilizarDocumentoEletronico(string pChaveAcesso, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade, string pSerie, int pNumeroInicial, int pNumeroFinal, string pAno, int pCodigoUsuario, string pJustificativa)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\InutilizarDocumentoEletronico\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}_{2}.log", DateTime.Now.ToString("HHmmss"), pCodigoUsuario.ToString(), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            AvaCorp.Virtual.WS.Inutilizar inutilizar = new AvaCorp.Virtual.WS.Inutilizar();
            return inutilizar.DocumentoEletronico(pChaveAcesso, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pSerie, pNumeroInicial, pNumeroFinal, pAno, pCodigoUsuario, pJustificativa);
        }
        finally
        {
            #region fechar log

            if (Auditoria.GravarLog) auditoria.CloseMonitor();

            #endregion
        }
    }

    [WebMethod]
    public AvaCorp.Virtual.Types.Retorno InutilizarFaixaDocumentoEletronico(string pChaveAcesso, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade, string pSerie, int pNumeroInicial, int pNumeroFinal, string pAno, int pCodigoUsuario, string pJustificativa)
    {
        AvaCorp.Virtual.Types.Retorno retorno = new AvaCorp.Virtual.Types.Retorno();

        int posicaoAtual = 0;
        int posicaoFinal = 0;

        for (int i = pNumeroInicial; i <= pNumeroFinal; i++)
        {
            posicaoAtual = i;
            posicaoFinal = i + 999;
            if (posicaoFinal >= pNumeroFinal)
            {
                posicaoFinal = pNumeroFinal;
            }

            retorno = InutilizarDocumentoEletronico(pChaveAcesso, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pSerie, posicaoAtual,
                                                                    posicaoFinal, pAno, pCodigoUsuario, pJustificativa);
            //XmlDocument xmlSalvar = new XmlDocument();
            //xmlSalvar.InnerXml = xmlInutilizado.OuterXml;
            //xmlSalvar.Save(String.Format(@"{0}\filial{1}-unidade{2}-serie{3}-numeroinicial{4}-numerofinal{5}.xml", Serializacao.CaminhoInutilizacao, pFilial, pUnidade, pSerie, i, posicaoFinal));

            for (int j = i; j <= posicaoFinal; j++)
            {
                if (posicaoAtual <= pNumeroFinal - 1)
                {
                    posicaoAtual = j;
                }
            }
            i = posicaoAtual;
        }
        return retorno;
    }

    [WebMethod]
    public XmlDocument ConsultarStatusServico(string pChaveAcesso, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\ConsultarStatusServico\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}.log", DateTime.Now.ToString("HHmmss"), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion
            AvaCorp.Virtual.WS.StatusServico statusServico = new AvaCorp.Virtual.WS.StatusServico();
            return statusServico.ConsultaCompleta(pChaveAcesso, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade);
        }
        finally
        {
            #region fechar log

            if (Auditoria.GravarLog) auditoria.CloseMonitor();

            #endregion
        }
    }

    [WebMethod]
    public AvaCorp.Virtual.Types.Retorno TestarConexaoBanco(string connectionString)
    {
        AvaCorp.Virtual.Types.Retorno retorno = new AvaCorp.Virtual.Types.Retorno();
        try
        {
            DALConnections.ConnectionString = connectionString;
            Empresa empresa = new Empresa();
            retorno.CodigoRetorno = true;
            retorno.DescricaoRetorno = empresa.Select();
        }
        catch (Exception ex)
        {
            retorno.CodigoRetorno = false;
            retorno.DescricaoRetorno = ex.Message;
        }
        return retorno;
    }
    #endregion

    #region SIM
    [WebMethod]
    public XmlNode ConsultaSimNFeCompleta(string chaveSim, string chaveAcesso, int grupo, int empresa, int filial)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\ConsultaSim\Completa\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}.log", DateTime.Now.ToString("HHmmss"), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            AvaCorp.Virtual.Services.SimConsultas.Consulta sim = new AvaCorp.Virtual.Services.SimConsultas.Consulta();
            return sim.Completa(chaveSim, chaveAcesso, true, grupo, empresa, filial);

        }
        catch (Exception) { throw; }
        finally
        {
            if (Auditoria.GravarLog) auditoria.CloseMonitor();
        }
    }
    [WebMethod]
    public string ConsultaSimNFeResumida(string chaveSim, string chaveAcesso, int grupo, int empresa, int filial)
    {
        Auditoria auditoria = new Auditoria();
        try
        {
            #region criar log
            if (Auditoria.GravarLog)
            {
                Auditoria.PathLog = Server.MapPath(String.Format(@"Log\ConsultaSim\Resumida\{0}\{1}\{2}\", DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0')));
                Auditoria.NomeArquivo = String.Format("{0}_{1}.log", DateTime.Now.ToString("HHmmss"), Guid.NewGuid());
                auditoria.OpenMonitor();
            }
            #endregion

            AvaCorp.Virtual.Services.SimConsultas.Consulta sim = new AvaCorp.Virtual.Services.SimConsultas.Consulta();
            return sim.Resumida(chaveSim, chaveAcesso, grupo, empresa, filial);
        }
        catch (Exception) { throw; }
        finally
        {
            if (Auditoria.GravarLog) auditoria.CloseMonitor();
        }
    }
    #endregion
    #endregion

    #region Private Methods
    /// <summary>
    /// Retorna a instncia da DLL ExportXML corresponde ao tipo de documento e a verso do Layout (Via Refletion)
    /// </summary>
    /// <param name="pTipoDocumento">Tipo de Documento</param>
    /// <param name="pVersaoLayout">Verso do Layout</param>
    /// <returns></returns>
    private XmlDocument GetTypeExportXML(int pTipoDocumento, string pVersaoLayout, string pNomeMetodo, List<Type> pTipoArgumentos, List<object> pValorArgumentos)
    {
        string urlWebService = System.Web.HttpContext.Current.Request.Url.OriginalString;
        // Remove Sufixo para pegar o endereo raiz do WS
        urlWebService = Regex.Replace(urlWebService, "/[0-9a-zA-Z_.-]+$", "");

        //Carrego o Assembly
        string assemblyPath = Server.MapPath(String.Format(@"bin\{0}\{1}\ExportXML.dll", pTipoDocumento == 12 ? "NFe" : "CTe", pVersaoLayout));
        System.Reflection.Assembly a = System.Reflection.Assembly.LoadFrom(assemblyPath);

        // Recebo o tipo da Classe que preciso instanciar passando namespace
        Type myType = a.GetType("AvaCorp.ExportXML");

        // Obtem a lista de construtores
        System.Reflection.ConstructorInfo[] constructoInfo = myType.GetConstructors();

        // Crio a instancia da classe e armazeno em um objeto 
        Object _InvokeParam1 = null;

        // Verifica se a classe que ser instanciada possui 1 ou 2 argumentos no construtor,
        // Pois nas verses mais antigas da ExportXML.dll havia apenas a ConnectionString
        if (constructoInfo.Where(x => constructoInfo[0].GetParameters().Count() == 2).Any())
            _InvokeParam1 = Activator.CreateInstance(myType, new object[] { DALConnections.ConnectionString, urlWebService });
        else
            _InvokeParam1 = Activator.CreateInstance(myType, new object[] { DALConnections.ConnectionString });

        // Recebo o metodo que ser invocado passando a assinatura
        System.Reflection.MethodInfo _method = myType.GetMethod(pNomeMetodo, pTipoArgumentos.ToArray());

        // Invoco o metodo passando a instancia da classe (construtor)  e os parametros do metodo
        return (XmlDocument)_method.Invoke(_InvokeParam1, pValorArgumentos.ToArray());

    }
    #endregion

    #region Log Methods
    /// <summary>
    /// Return a array of string containing a set of log
    /// </summary>
    /// <param name="pMethodTyped"></param>
    /// <param name="pDataSelecionada"></param>
    /// <returns></returns>
    [WebMethod]
    public string[] ListarArquivosLog(int pMethodTyped, DateTime pDataSelecionada)
    {
        try
        {
            string currentDirectory = Server.MapPath(@"Log");
            return Directory.GetFiles(String.Format(@"{0}\{1}\", currentDirectory, GetMethodTypedLog(pMethodTyped, pDataSelecionada)));
        }
        catch (DirectoryNotFoundException ex)
        {
            throw new Exception("Mtodo selecionado e/ou Data no contm arquivos de log " + ex.InnerException);
        }
        catch (Exception ex)
        {
            throw new Exception(ex.Message);
        }
    }

    /// <summary>
    /// Return the path of logs, methods was build to be displayed by UI
    /// </summary>
    /// <param name="pMethodType"></param>
    /// <param name="pDataSelecionada"></param>
    /// <returns></returns>
    private string GetMethodTypedLog(int pMethodType, DateTime pDataSelecionada)
    {
        switch (pMethodType)
        {
            case 0: return String.Format(@"EnviarDocumentoEletronico\{0}", pDataSelecionada.ToString("yyyy/MM/dd/"));
            case 1: return String.Format(@"RetornoRecepcaoDocumentoEletronico\{0}", pDataSelecionada.ToString("yyyy/MM/dd/"));
            case 2: return String.Format(@"CancelamentoDocumentoEletronico\{0}", pDataSelecionada.ToString("yyyy/MM/dd/"));
            case 3: return String.Format(@"CopiaEletronicaFatura\{0}", pDataSelecionada.ToString("yyyy/MM/dd/"));
            case 4: return String.Format(@"EnviarEmailParaAvacorp\{0}", pDataSelecionada.ToString("yyyy/MM/dd/"));
            case 5: return String.Format(@"ConsultarSituacaoDocumento\{0}", pDataSelecionada.ToString("yyyy/MM/dd/"));
            case 6: return String.Format(@"InutilizarDocumentoEletronico\{0}", pDataSelecionada.ToString("yyyy/MM/dd/"));
            case 7: return String.Format(@"ConsultarStatusServico\{0}", pDataSelecionada.ToString("yyyy/MM/dd/"));
            default:
                throw new Exception("Documento errado");
        }
    }

    /// <summary>
    /// Return a data of the selected log
    /// </summary>
    /// <param name="pLog"></param>
    /// <returns></returns>
    [WebMethod]
    public string RetornaConteudoLog(string pLog)
    {
        using (FileStream fileStream = new FileStream(pLog, FileMode.Open, FileAccess.Read))
        {
            try
            {
                using (StreamReader sr = new StreamReader(fileStream))
                {
                    return sr.ReadToEnd();
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
    }
    #endregion
}