using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using AvaCorp.Virtual.BLL;
using AvaCorp.Virtual.Util;
using AvaCorp.Virtual.BLL.Common.XML;
using System.Collections;
using AvaCorp.Virtual.BLL.CTe.XML;
using AvaCorp.Virtual.Services.CTe;
using AvaCorp.Virtual.BLL.NFe.XML;

namespace AvaCorp.Virtual.WS
{
    /// <summary>
    /// Summary description for ConsultaSituacaoDocumento
    /// </summary>
    public class SituacaoDocumento
    {
        public SituacaoDocumento()
        {
            FillHashTipoDocumento();
        }

        private Hashtable tipoDocumentoHash = new Hashtable();

        private void FillHashTipoDocumento()
        {
            tipoDocumentoHash.Add(6, @"CTe\Rodo\");
            tipoDocumentoHash.Add(12, @"NFe\");
            tipoDocumentoHash.Add(97, @"CTe\Aereo\");
        }

        public XmlDocument Consultar(string chaveAcesso)
        {
            Services.CTe.SituacaoDocumento consultaCTe = new Services.CTe.SituacaoDocumento();
            return consultaCTe.WSRedirecionarEDIWS(chaveAcesso);

            XmlDocument xmlConsultaDocumento = new XmlDocument();
            Serializacao serializacao = new Serializacao();
            try
            {
                DALConnections.BeginTransaction();
                int tipoDocumento = chaveAcesso.Substring(20, 2) == "55" ? 12 : 6;
                int servicoDocumentoEletronico = tipoDocumento == 12 ? 31 : 13;

                Types.Estado_ParametroDocumentoEletronico estado = new Estado_ParametroDocumentoEletronico().Select("BRA", System.Enum.GetName(typeof(TUf), Convert.ToInt32(chaveAcesso.Substring(0, 2))), tipoDocumento, servicoDocumentoEletronico);

                #region Carrega todos certificados cadastrados no sistema e faz a validao
                System.Collections.Generic.List<string> certificados = BLL.Empresa_Configuracao.Fill();
                string serial = String.Empty;
                Certificado certificate = new Certificado();
                foreach (string certificado in certificados)
                {
                    if (certificate.IsValid(certificado))
                        serial = certificado;
                }
                #endregion

                Types.DocumentoEletronicoLote_Documento doc = new BLL.DocumentoEletronicoLote_Documento().PossuiDocumentoNoBanco(chaveAcesso);

                if (String.IsNullOrEmpty(serial))
                    throw new Exception("Nao existe certificado digital valido");
                else
                {
                    switch (tipoDocumento)
                    {
                        case 6:
                        case 97:
                            //Services.CTe.SituacaoDocumento consultaCTe = new Services.CTe.SituacaoDocumento();
                            TRetConsSitCTe retConsSitCTe = consultaCTe.WSRetornaSituacaoCTe(chaveAcesso, 1, estado, serial);
                            xmlConsultaDocumento = serializacao.GetMemoryXML(typeof(TRetConsSitCTe), retConsSitCTe);

                            if (doc.HasValue && retConsSitCTe.Item != null && (doc.Situacao == 204 || doc.NumeroProtocolo == 0))
                            {
                                string numeroProtocolo = ((TProtCTe)retConsSitCTe.Item).infProt.nProt;
                                AtualizaDocumento(chaveAcesso, retConsSitCTe.cStat, numeroProtocolo);
                            }
                            break;
                        case 12:
                            TRetConsSitNFe retConsSitNFe = new TRetConsSitNFe();

                            if (estado.CodigoIBGEEstado == 29)
                            {
                                Services.NFe310.SituacaoDocumento consultaNFe = new Services.NFe310.SituacaoDocumento();
                                retConsSitNFe = consultaNFe.WSRetornaSituacaoNFe(chaveAcesso, 1, estado, serial);
                            }
                            else if (estado.CodigoIBGEEstado == 41)
                            {
                                Services.NFe310_PR.SituacaoDocumento consultaNFe = new Services.NFe310_PR.SituacaoDocumento();
                                retConsSitNFe = consultaNFe.WSRetornaSituacaoNFe(chaveAcesso, 1, estado, serial);
                            }
                            else
                            {
                                Services.NFe.SituacaoDocumento consultaNFe = new Services.NFe.SituacaoDocumento();
                                retConsSitNFe = consultaNFe.WSRetornaSituacaoNFe(chaveAcesso, 1, estado, serial);
                            }

                            xmlConsultaDocumento = serializacao.GetMemoryXML(typeof(TRetConsSitNFe), retConsSitNFe);

                            if (doc.HasValue && retConsSitNFe.protNFe != null && (doc.Situacao == 204 || doc.NumeroProtocolo == 0))
                            {
                                AtualizaDocumento(chaveAcesso, retConsSitNFe.cStat, retConsSitNFe.protNFe.infProt.nProt);
                            }
                            break;
                        default:
                            break;
                    }
                }

                #region Atualiza a tabela logSistema
                System.Diagnostics.StackFrame stack = new System.Diagnostics.StackFrame(2);
                string rotina = stack.GetMethod().ToString();
                int usuario = 1;
                string mensagem;
                string contexto;

                #region Atualiza a tabela logSistema apos consulta

                contexto = "Consulta Documento";
                mensagem = string.Format("Chave acesso: {0}", chaveAcesso);
                AvaCorp.Virtual.BLL.LogSistema.LogUtilizacaoServicos(usuario, rotina, mensagem, contexto);
                #endregion
                #endregion

                DALConnections.CommitTransaction();
            }
            catch (Exception ex)
            {
                Auditoria.GravaMensagem(ex.Message);
                DALConnections.RollbackTransaction();
                LogSource.Log.GravarMensagem(Convert.ToInt32(chaveAcesso.Substring(20, 2)), ex, 1, "Situao Documento", DALConnections.ConnectionString, String.Empty);
                return xmlConsultaDocumento;
            }
            return xmlConsultaDocumento;
        }

        private void AtualizaDocumento(string chaveAcesso, string situacao, string protocolo)
        {
            try
            {
                new BLL.DocumentoEletronicoLote_Documento().Update(chaveAcesso, Convert.ToInt32(situacao), Convert.ToInt64(protocolo));
                //Lotes antigos quando o cStat = 204 a situao do lote ficava = 2 (em processamento). Como o documento est autorizado ser alterado a situao do lote para 3 - processado.
                new BLL.DocumentoEletronicoLote().UpdateSituacaoLote(chaveAcesso);
            }
            catch (Exception ex) { throw ex; }
        }

        public XmlDocument Consultar(string pChaveAcessoWebService, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade, string pCnpjCpfCodigoEmissor, int pDiferenciadorNumero, int pSerie, int pNumero)
        {
            XmlDocument xmlConsultaDocumento = new XmlDocument();
            try
            {
                DALConnections.BeginTransaction();
                Auditoria.GravaMensagem(String.Format("ConsultaSituacaoDocumento\tChaveAcesso:{0}\tTipoDocumento:{1}\tGrupo:{2}Empresa:{3}\tFilial:{4}\tUnidade:{5}\tCnpjCpfCodigoEmissor:{6}\tDiferenciadorNumero:{7}\tSerie:{8}\tNumero:{9}", pChaveAcessoWebService, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pCnpjCpfCodigoEmissor, pDiferenciadorNumero, pSerie, pNumero));
                Configuracoes.GetParametros(pGrupo, pEmpresa, pFilial, pUnidade, pTipoDocumento);
                int servicoDocumentoEletronico = pTipoDocumento == 12 ? 31 : 13;
                Serializacao serializacao = new Serializacao();

                BLL.Estado_ParametroDocumentoEletronico estadoBLL = new Estado_ParametroDocumentoEletronico();
                Types.Estado_ParametroDocumentoEletronico estadoParametroDocumentoEletronico = estadoBLL.Select("BRA", AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, servicoDocumentoEletronico);

                DocumentoEletronicoLote_Documento bllDocumento = new DocumentoEletronicoLote_Documento();
                AvaCorp.Virtual.Types.DocumentoEletronicoLote_Documento documento = new AvaCorp.Virtual.Types.DocumentoEletronicoLote_Documento();
                documento = bllDocumento.SelectDocumentoOrigem(pGrupo, pEmpresa, pFilial, pUnidade, pCnpjCpfCodigoEmissor, pDiferenciadorNumero, pSerie, pNumero, pTipoDocumento);

                #region Sincroniza a situao do documento pelo EDIWS
                #region CTe v2.00/v3.00
                if (pTipoDocumento == 6 && (estadoParametroDocumentoEletronico.VersaoLayout == "2.00" || estadoParametroDocumentoEletronico.VersaoLayout == "3.00"))
                {
                    try
                    {
                        // Se vai fazer a transmisso pelo EDIWS, aborta a transao, pois ela no  mais necessria
                        DALConnections.RollbackTransaction();

                        var syncEDIWS = new Services.CTe.SituacaoDocumento();
                        var retSyscEDIWS = syncEDIWS.SincronizarEDIWS(pChaveAcessoWebService, documento.ChaveAcesso);

                        XmlDocument xmlSyndEDIWS = new XmlDocument();
                        xmlSyndEDIWS.LoadXml(string.Format("<EDIWS><descricaoResposta>{0}</descricaoResposta></EDIWS>", retSyscEDIWS.DescricaoRetorno));
                        return xmlSyndEDIWS;
                    }
                    catch (Exception ex)
                    {
                        string msg = string.Format("Problemas ao consultar a situao documento pelo EDIWS: {0}", ex.Message);

                        XmlDocument xmlSyndEDIWS = new XmlDocument();
                        xmlSyndEDIWS.LoadXml(string.Format("<ERRO>{0}</ERRO>", msg));
                        return xmlSyndEDIWS;
                    }
                }
                #endregion
                #region NFe v3.10/v4.00
                if (pTipoDocumento == 12 && (estadoParametroDocumentoEletronico.VersaoLayout == "3.10" || estadoParametroDocumentoEletronico.VersaoLayout == "4.00"))
                {
                    try
                    {
                        // Se vai fazer a transmisso pelo EDIWS, aborta a transao, pois ela no  mais necessria
                        DALConnections.RollbackTransaction();

                        var syncEDIWS = new Services.NFe.SituacaoDocumento();
                        var retSyscEDIWS = syncEDIWS.SincronizarEDIWS(pChaveAcessoWebService, documento.ChaveAcesso);

                        XmlDocument xmlSyndEDIWS = new XmlDocument();
                        xmlSyndEDIWS.LoadXml(string.Format("<EDIWS><descricaoResposta>{0}</descricaoResposta></EDIWS>", retSyscEDIWS.DescricaoRetorno));
                        return xmlSyndEDIWS;
                    }
                    catch (Exception ex)
                    {
                        string msg = string.Format("Problemas ao consultar a situao documento pelo EDIWS: {0}", ex.Message);

                        XmlDocument xmlSyndEDIWS = new XmlDocument();
                        xmlSyndEDIWS.LoadXml(string.Format("<ERRO>{0}</ERRO>", msg));
                        return xmlSyndEDIWS;
                    }
                }
                #endregion
                #endregion

                //TAmb ambienteEmissao = documento.AmbienteEmissao == 1 ? TAmb.Item1 : TAmb.Item2;
                switch (pTipoDocumento)
                {
                    case 6:
                    case 97:
                        AvaCorp.Virtual.Services.CTe.SituacaoDocumento consultaCTe = new AvaCorp.Virtual.Services.CTe.SituacaoDocumento();
                        TRetConsSitCTe retConsSitCTe = consultaCTe.WSRetornaSituacaoCTe(documento.ChaveAcesso, documento.AmbienteEmissao, estadoParametroDocumentoEletronico, pGrupo, pEmpresa);
                        xmlConsultaDocumento = serializacao.GetMemoryXML(typeof(TRetConsSitCTe), retConsSitCTe);
                        Serializacao.CaminhoConsultaSituacao += String.Format(@"{0}{1}\", tipoDocumentoHash[pTipoDocumento], AvaCorp.Virtual.Types.Unidade_Parametro.CodigoIBGEEstado);
                        xmlConsultaDocumento.Save(String.Format("{0}{1}-sit.xml", Serializacao.CaminhoConsultaSituacao, documento.ChaveAcesso));
                        DALConnections.CommitTransaction();
                        break;
                    case 12:
                        AvaCorp.Virtual.Services.NFe.SituacaoDocumento consultaNFe = new AvaCorp.Virtual.Services.NFe.SituacaoDocumento();
                        TRetConsSitNFe retConsSitNFe = consultaNFe.WSRetornaSituacaoNFe(documento.ChaveAcesso, documento.AmbienteEmissao, estadoParametroDocumentoEletronico, pGrupo, pEmpresa);
                        xmlConsultaDocumento = serializacao.GetMemoryXML(typeof(TRetConsSitNFe), retConsSitNFe);
                        Serializacao.CaminhoConsultaSituacao += String.Format(@"{0}{1}\", tipoDocumentoHash[pTipoDocumento], AvaCorp.Virtual.Types.Unidade_Parametro.CodigoIBGEEstado);
                        xmlConsultaDocumento.Save(String.Format("{0}{1}-sit.xml", Serializacao.CaminhoConsultaSituacao, documento.ChaveAcesso));
                        DALConnections.CommitTransaction();
                        break;
                    default:
                        break;
                }

            }
            catch (Exception ex)
            {
                Auditoria.GravaMensagem(ex.Message);
                DALConnections.RollbackTransaction();
                LogSource.Log.GravarMensagem(pTipoDocumento, ex, 1, "Situao Documento", DALConnections.ConnectionString, String.Empty);
                return xmlConsultaDocumento;
            }
            return xmlConsultaDocumento;
        }

        /// <summary>
        /// Quando ocorrer o cdigo de status 204 (Rejeio: Documento eletrnico j consta como autorizado na SEFAZ) o mesmo dever ser autorizado automaticamente.
        /// Ser buscado na SEFAZ o nmero de protocolo de aurorizao
        /// </summary>
        /// <param name="pTipoDocumento"></param>
        /// <param name="pGrupo"></param>
        /// <param name="pEmpresa"></param>
        /// <param name="pFilial"></param>
        /// <param name="pUnidade"></param>
        /// <param name="pCnpjCpfCodigoEmissor"></param>
        /// <param name="pDiferenciadorNumero"></param>
        /// <param name="pSerie"></param>
        /// <param name="pNumero"></param>
        /// <param name="pNumeroProtocolo"></param>
        public void AtualizaProtocolo(string pChaveAcessoWebService, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade, string pCnpjCpfCodigoEmissor, int pDiferenciadorNumero, int pSerie, int pNumero)
        {
            try
            {
                DALConnections.BeginTransaction();
                Auditoria.GravaMensagem(String.Format("ConsultaSituacaoDocumento\tChaveAcesso:{0}\tTipoDocumento:{1}\tGrupo:{2}Empresa:{3}\tFilial:{4}\tUnidade:{5}\tCnpjCpfCodigoEmissor:{6}\tDiferenciadorNumero:{7}\tSerie:{8}\tNumero:{9}", pChaveAcessoWebService, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pCnpjCpfCodigoEmissor, pDiferenciadorNumero, pSerie, pNumero));
                Configuracoes.GetParametros(pGrupo, pEmpresa, pFilial, pUnidade, pTipoDocumento);
                int servicoDocumentoEletronico = pTipoDocumento == 12 ? 31 : 13;
                Serializacao serializacao = new Serializacao();

                BLL.Estado_ParametroDocumentoEletronico estadoBLL = new Estado_ParametroDocumentoEletronico();
                Types.Estado_ParametroDocumentoEletronico estadoParametroDocumentoEletronico = estadoBLL.Select("BRA", AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, servicoDocumentoEletronico);

                DocumentoEletronicoLote_Documento bllDocumento = new DocumentoEletronicoLote_Documento();
                AvaCorp.Virtual.Types.DocumentoEletronicoLote_Documento documento = new AvaCorp.Virtual.Types.DocumentoEletronicoLote_Documento();
                documento = bllDocumento.SelectDocumentoOrigem(pGrupo, pEmpresa, pFilial, pUnidade, pCnpjCpfCodigoEmissor, pDiferenciadorNumero, pSerie, pNumero, pTipoDocumento);
                //TAmb ambienteEmissao = documento.AmbienteEmissao == 1 ? TAmb.Item1 : TAmb.Item2;
                switch (pTipoDocumento)
                {
                    case 6:
                    case 97:
                        AvaCorp.Virtual.Services.CTe.SituacaoDocumento consultaCTe = new AvaCorp.Virtual.Services.CTe.SituacaoDocumento();
                        TRetConsSitCTe retConsSitCTe = consultaCTe.WSRetornaSituacaoCTe(documento.ChaveAcesso, documento.AmbienteEmissao, estadoParametroDocumentoEletronico, pGrupo, pEmpresa);
                        if (retConsSitCTe.Item != null)
                        {
                            TProtCTe protCTe = (TProtCTe)retConsSitCTe.Item;
                            bllDocumento.UpdateProtocoloRejeitado(pGrupo, pEmpresa, AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, documento.NumeroLote, pNumero,
                                protCTe.infProt.nProt, protCTe.infProt.cStat);
                            DALConnections.CommitTransaction();
                        }
                        else
                            DALConnections.RollbackTransaction();
                        break;
                    case 12:
                        AvaCorp.Virtual.Services.NFe.SituacaoDocumento consultaNFe = new AvaCorp.Virtual.Services.NFe.SituacaoDocumento();
                        TRetConsSitNFe retConsSitNFe = consultaNFe.WSRetornaSituacaoNFe(documento.ChaveAcesso, documento.AmbienteEmissao, estadoParametroDocumentoEletronico, pGrupo, pEmpresa);
                        if (retConsSitNFe.protNFe != null)
                        {
                            bllDocumento.UpdateProtocoloRejeitado(pGrupo, pEmpresa, AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, documento.NumeroLote, pNumero,
                                retConsSitNFe.protNFe.infProt.nProt, retConsSitNFe.protNFe.infProt.cStat);
                            DALConnections.CommitTransaction();
                        }
                        else
                            DALConnections.RollbackTransaction();
                        break;
                    default:
                        throw new Exception("Documento no implementado");
                }

            }
            catch (Exception ex)
            {
                Auditoria.GravaMensagem(ex.Message);
                DALConnections.RollbackTransaction();
                LogSource.Log.GravarMensagem(pTipoDocumento, ex, 1, "Situao documento atualizar", DALConnections.ConnectionString, String.Empty);
            }
        }
    }
}