using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using AvaCorp.Virtual.Util;
using AvaCorp.Virtual.BLL;
using AvaCorp.Virtual.BLL.CTe.XML;
using AvaCorp.Virtual.Services.CTe.Inutilizacao;
using AvaCorp.Virtual.Services.NFe.Inutilizacao;
//using AvaCorp.Virtual.Util.UI;
using AvaCorp.Virtual.BLL.NFe.XML;
//using ExportXML;

namespace AvaCorp.Virtual.WS
{
    /// <summary>
    /// Summary description for Inutilizar
    /// </summary>
    public class Inutilizar
    {
        public Inutilizar() {}

        public Types.Retorno DocumentoEletronico(string pChaveAcessoWebService, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade, string pSerie, int pNumeroInicial, int pNumeroFinal, string pAno, int pCodigoUsuario, string pJustificativa)
        {
            Serializacao serializacao = new Serializacao();
            Inutilizacao inutilizacao = new Inutilizacao();
            XmlDocument xmlRetornoInutilizacao = new XmlDocument();
            Types.Retorno retorno = new Types.Retorno();
            try
            {
                Auditoria.GravaMensagem(String.Format("Inutilizar\tChaveAcesso:{0}\tTipoDocumento:{1}\tGrupo:{2}\tEmpresa:{3}\tFilial:{4}\tUnidade:{5}\tSerie:{6}\tNumeroInicial:{7}\tNumeroFinal:{8}\tAno:{9}\tCodigoUsuario:{10}\tJustificativa:{11})", pChaveAcessoWebService, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pSerie, pNumeroInicial, pNumeroFinal, pAno, pCodigoUsuario, pJustificativa));
                DALConnections.BeginTransaction();
                Configuracoes.GetParametros(pGrupo, pEmpresa, pFilial, pUnidade, pTipoDocumento);
                if (Configuracoes.TestaEnvioDocumento(pGrupo, pEmpresa, pChaveAcessoWebService) == false)
                {
                    Auditoria.GravaMensagem("Documento no permite inutilizao");
                    throw new Exception("Documento no permite inutilizao");
                }

                int servicoDocumentoEletronico = pTipoDocumento == 12 ? 28 : 10;
                BLL.Estado_ParametroDocumentoEletronico estadoBLL = new Estado_ParametroDocumentoEletronico();
                Types.Estado_ParametroDocumentoEletronico estadoParametroDocumentoEletronico = estadoBLL.Select("BRA", AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, servicoDocumentoEletronico);

                #region Inutilizar numerao atravs do EDIWS
                #region CTe v2.00/v3.00
                if (pTipoDocumento == 6 && (estadoParametroDocumentoEletronico.VersaoLayout == "2.00" || estadoParametroDocumentoEletronico.VersaoLayout == "3.00"))
                {
                    try
                    {
                        var serie = new BLL.Serie().Select(pGrupo, pEmpresa, Convert.ToInt32(pSerie));
                        
                        // Se vai fazer a transmisso pelo EDIWS, aborta a transao, pois ela no  mais necessria
                        DALConnections.RollbackTransaction();

                        var inutilizacaoCTe = new Services.CTe.Inutilizacao.InutilizacaoCTe();
                        return inutilizacaoCTe.InutilizarFaixaEDIWS(pChaveAcessoWebService, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, serie.Codigo, pCodigoUsuario, int.Parse(pAno), pNumeroInicial, pNumeroFinal, pJustificativa);
                    }
                    catch (Exception ex)
                    {
                        retorno.CodigoRetorno = false;
                        retorno.DescricaoRetorno = String.Format("Problemas ao Inutilizar Faixa pelo EDIWS: {0}", ex.Message);
                        return retorno;
                    }
                }
                #endregion
                #region NFe v3.10/v4.00
                if (pTipoDocumento == 12 && (estadoParametroDocumentoEletronico.VersaoLayout == "3.10" || estadoParametroDocumentoEletronico.VersaoLayout == "4.00"))
                {
                    try
                    {
                        var serie = new BLL.Serie().SelectBySigla(pGrupo, pEmpresa, pSerie);

                        // Se vai fazer a transmisso pelo EDIWS, aborta a transao, pois ela no  mais necessria
                        DALConnections.RollbackTransaction();

                        var inutilizacaoNFe = new Services.NFe.Inutilizacao.InutilizacaoNFe();
                        return inutilizacaoNFe.InutilizarFaixaEDIWS(pChaveAcessoWebService, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, serie.Codigo, pCodigoUsuario, int.Parse(pAno), pNumeroInicial, pNumeroFinal, pJustificativa);
                    }
                    catch (Exception ex)
                    {
                        retorno.CodigoRetorno = false;
                        retorno.DescricaoRetorno = String.Format("Problemas ao Inutilizar Faixa pelo EDIWS: {0}", ex.Message);
                        return retorno;
                    }
                }
                #endregion
                #endregion

                XmlDocument xmlEnvioInutilizacao = inutilizacao.InutilizaDocumento(pChaveAcessoWebService, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pSerie, pNumeroInicial, pNumeroFinal, pAno.PadLeft(2, '0'), pJustificativa.Trim(), estadoParametroDocumentoEletronico);
                string arquivoEnvio = String.Empty;
                string arquivoRetornoEnvio = String.Empty;

                switch (pTipoDocumento)
                {
                    case 6:
                    case 97:
                        #region Inutilizar CT-e
                        InutilizacaoCTe inutilizacaoCTe = new InutilizacaoCTe();
                        TRetInutCTe retInutCTe = inutilizacaoCTe.WSInutilizaCTe(xmlEnvioInutilizacao, estadoParametroDocumentoEletronico, pGrupo, pEmpresa);

                        arquivoEnvio = String.Format(@"{0}{1}{2}57{3}{4}{5}-ped-inu.xml", Types.Unidade_Parametro.UFEmissor, pAno, Types.Unidade_Parametro.CnpjEmitente, pSerie, pNumeroInicial, pNumeroFinal);
                        xmlEnvioInutilizacao.Save(String.Format(@"{0}{1}", Serializacao.CaminhoInutilizacao, arquivoEnvio));

                        xmlRetornoInutilizacao = serializacao.GetMemoryXML(typeof(TRetInutCTe), retInutCTe);
                        arquivoRetornoEnvio = String.Format(@"{0}{1}{2}57{3}{4}{5}-inu.xml", Serializacao.CaminhoInutilizacao, pAno, Types.Unidade_Parametro.CnpjEmitente, pSerie, pNumeroInicial, pNumeroFinal);
                        if (System.IO.File.Exists(arquivoRetornoEnvio))
                            xmlRetornoInutilizacao.Save(String.Format(@"{0}{1}{2}57{3}{4}{5}-inu-new.xml", Serializacao.CaminhoInutilizacao, pAno, Types.Unidade_Parametro.CnpjEmitente, pSerie, pNumeroInicial, pNumeroFinal));
                        else
                            xmlRetornoInutilizacao.Save(String.Format(@"{0}", arquivoRetornoEnvio));

                        if (retInutCTe.infInut.cStat == "102") //Inutilizao de nmero homologado
                        {
                            Auditoria.GravaMensagem(String.Format("{0} - {1}", retInutCTe.infInut.cStat, retInutCTe.infInut.xMotivo));
                            DALConnections.CommitTransaction();
                            retorno.CodigoRetorno = true;
                            retorno.DescricaoRetorno = retInutCTe.infInut.xMotivo;
                        }
                        else
                        {
                            Auditoria.GravaMensagem(String.Format("{0} - {1}", retInutCTe.infInut.cStat, retInutCTe.infInut.xMotivo));
                            DALConnections.RollbackTransaction();
                            retorno.CodigoRetorno = false;
                            retorno.DescricaoRetorno = retInutCTe.infInut.xMotivo;
                        }
                        if (!retInutCTe.infInut.dhRecbtoSpecified) retInutCTe.infInut.dhRecbto = DateTime.Now;
                        GravarXmlRetornoInutilizacao(pGrupo, pEmpresa, Types.Unidade_Parametro.UFEmissor, pTipoDocumento, retInutCTe.infInut.dhRecbto, xmlEnvioInutilizacao.InnerXml, xmlRetornoInutilizacao.InnerXml);

                        GravarDocumentoEletronicoInutilizadoCTe(retInutCTe.infInut, pTipoDocumento, pGrupo, pEmpresa, Types.Unidade_Parametro.CnpjEmitente, pFilial, pUnidade, Types.Unidade_Parametro.DiferenciadorNumeroPadrao, 
                            int.Parse(pSerie), pNumeroInicial, pNumeroFinal, pCodigoUsuario, pJustificativa, xmlEnvioInutilizacao.InnerXml, xmlRetornoInutilizacao.InnerXml);
                                               
                        #endregion
                        break;
                    case 12:
                        #region Inutilizar NF-e
                        InutilizacaoNFe inutilizacaoNFe = new InutilizacaoNFe();
                        TRetInutNFe retInutNFe = inutilizacaoNFe.WSInutilizaNFe(xmlEnvioInutilizacao, estadoParametroDocumentoEletronico, pGrupo, pEmpresa);

                        arquivoEnvio = String.Format(@"{0}{1}{2}57{3}{4}{5}-ped-inu.xml", Types.Unidade_Parametro.UFEmissor, pAno, Types.Unidade_Parametro.CnpjEmitente, pSerie, pNumeroInicial, pNumeroFinal);
                        xmlEnvioInutilizacao.Save(String.Format(@"{0}{1}", Serializacao.CaminhoInutilizacao, arquivoEnvio));

                        xmlRetornoInutilizacao = serializacao.GetMemoryXML(typeof(TRetInutNFe), retInutNFe);
                        arquivoRetornoEnvio = String.Format(@"{0}{1}{2}57{3}{4}{5}-inu.xml", Serializacao.CaminhoInutilizacao, pAno, Types.Unidade_Parametro.CnpjEmitente, pSerie, pNumeroInicial, pNumeroFinal);
                        if (System.IO.File.Exists(arquivoRetornoEnvio))
                            xmlRetornoInutilizacao.Save(String.Format(@"{0}{1}{2}57{3}{4}{5}-inu-new.xml", Serializacao.CaminhoInutilizacao, pAno, Types.Unidade_Parametro.CnpjEmitente, pSerie, pNumeroInicial, pNumeroFinal));
                        else
                            xmlRetornoInutilizacao.Save(String.Format(@"{0}", arquivoRetornoEnvio));

                        if (retInutNFe.infInut.cStat == "102") //Inutilizao de nmero homologado
                        {
                            Auditoria.GravaMensagem(String.Format("{0} - {1}", retInutNFe.infInut.cStat, retInutNFe.infInut.xMotivo));
                            DALConnections.CommitTransaction();
                            retorno.CodigoRetorno = true;
                            retorno.DescricaoRetorno = retInutNFe.infInut.xMotivo;
                        }
                        else
                        {
                            Auditoria.GravaMensagem(String.Format("{0} - {1}", retInutNFe.infInut.cStat, retInutNFe.infInut.xMotivo));
                            DALConnections.RollbackTransaction();
                            retorno.CodigoRetorno = false;
                            retorno.DescricaoRetorno = retInutNFe.infInut.xMotivo;
                        }
                        if (!retInutNFe.infInut.dhRecbtoSpecified) retInutNFe.infInut.dhRecbto = DateTime.Now;
                            GravarXmlRetornoInutilizacao(pGrupo, pEmpresa, Types.Unidade_Parametro.UFEmissor, pTipoDocumento, retInutNFe.infInut.dhRecbto, xmlEnvioInutilizacao.InnerXml, xmlRetornoInutilizacao.InnerXml);
                            GravarDocumentoEletronicoInutilizadoNFe(retInutNFe.infInut, pTipoDocumento, pGrupo, pEmpresa, Types.Unidade_Parametro.CnpjEmitente, pFilial, pUnidade, Types.Unidade_Parametro.DiferenciadorNumeroPadrao, 
                                int.Parse(pSerie), pNumeroInicial, pNumeroFinal, pCodigoUsuario, pJustificativa, xmlEnvioInutilizacao.InnerXml, xmlRetornoInutilizacao.InnerXml);
                        #endregion
                        break;
                    default:
                        throw new Exception("Documento no permite inutilizao");
                }
                return retorno;
            }
            catch (Exception ex)
            {
                DALConnections.RollbackTransaction();
                retorno.DescricaoRetorno = String.Format("Problemas ao Inutilizar documento {0}.", ex.Message);
                Auditoria.GravaMensagem(retorno.DescricaoRetorno + ex.StackTrace);
                LogSource.Log.GravarMensagem(pTipoDocumento, ex, pCodigoUsuario, "Inutilizar", DALConnections.ConnectionString, retorno.DescricaoRetorno);
                return retorno;
            }
        }

        private void GravarXmlRetornoInutilizacao(int pGrupo, int pEmpresa, string pUF, int pTipoDocumento, DateTime pDtCancelamento, string pXmlEnvio, string pXmlRetornoProcessamento)
        {
            try
            {
                XmlDocumentoEletronicoInutilizacao xmlDocumentoEletronicoInutilizacao = new XmlDocumentoEletronicoInutilizacao();
                xmlDocumentoEletronicoInutilizacao.Insert(pGrupo, pEmpresa, pUF, pTipoDocumento, pDtCancelamento, pXmlEnvio, pXmlRetornoProcessamento);
            }
            catch (Exception ex)
            {
                Auditoria.GravaMensagem(ex.Message);
            }
        }

        private void GravarDocumentoEletronicoInutilizadoCTe(TRetInutCTeInfInut retInut, int pTipoDocumento, int pGrupo, int pEmpresa,
            string pCnpjCpfCodigo, int pFilial, int pUnidade, int pDiferenciadorNumero, int pSerie, int pNumeroInicial,
            int pNumeroFinal, int pCodigoUsuario, string pJustificativa, string pXmlEnvio, string pXmlRetornoProcessamento)
        {
            try
            {
                DocumentoEletronicoInutilizacao documentoEletronicoInutilizacao = new DocumentoEletronicoInutilizacao();
                documentoEletronicoInutilizacao.InsertByWSCTe(retInut, pTipoDocumento, pGrupo, pEmpresa, pCnpjCpfCodigo, pFilial, pUnidade,
                    pDiferenciadorNumero, pSerie, pNumeroInicial, pNumeroFinal, pCodigoUsuario, pJustificativa, pXmlEnvio,
                    pXmlRetornoProcessamento);
            }
            catch (Exception ex)
            {
                Auditoria.GravaMensagem(ex.Message);
            }
        }

        private void GravarDocumentoEletronicoInutilizadoNFe(TRetInutNFeInfInut retInut, int pTipoDocumento, int pGrupo, int pEmpresa,
            string pCnpjCpfCodigo, int pFilial, int pUnidade, int pDiferenciadorNumero, int pSerie, int pNumeroInicial,
            int pNumeroFinal, int pCodigoUsuario, string pJustificativa, string pXmlEnvio, string pXmlRetornoProcessamento)
        {
            try
            {
                DocumentoEletronicoInutilizacao documentoEletronicoInutilizacao = new DocumentoEletronicoInutilizacao();
                documentoEletronicoInutilizacao.InsertByWSNFe(retInut, pTipoDocumento, pGrupo, pEmpresa, pCnpjCpfCodigo, pFilial, pUnidade,
                    pDiferenciadorNumero, pSerie, pNumeroInicial, pNumeroFinal, pCodigoUsuario, pJustificativa, pXmlEnvio,
                    pXmlRetornoProcessamento);
            }
            catch (Exception ex)
            {
                Auditoria.GravaMensagem(ex.Message);
            }
        }
    }
}